angular.module('focaConfigurarTerminal')
    .controller('focaConfigurarTerminalController', [
        '$scope',
        '$timeout',
        '$location',
        'focaConfigurarTerminalService',
        'focaBotoneraLateralService',
        'focaModalService',
        function(
            $scope,
            $timeout,
            $location,
            focaConfigurarTerminalService,
            focaBotoneraLateralService,
            focaModalService) {

            $scope.now = new Date();
            $scope.focused = 1;
            $scope.terminal = {
                variable: 'terminalId'
            };

            $timeout(function() {
                focaBotoneraLateralService.showSalir(true);
                focaBotoneraLateralService.showPausar(false);
                focaBotoneraLateralService.showCancelar(false);
                focaBotoneraLateralService.showGuardar(true, $scope.guardar);
            });

            $scope.guardar = function() {

                focaConfigurarTerminalService
                    .nombreEmpresa()
                    .then(function(res) {

                        var json = {
                            terminal: $scope.terminal,
                            empresa: res.data.NOM,
                            idEmpresa: res.data.idEmpresa
                        };

                        focaConfigurarTerminalService
                            .guardarTerminalBase(json)
                            .then(terminalLocal)
                            .catch(function(err) {

                                if(err.status === 404) {
                                    focaModalService.alert('Empresa no configurada');
                                    return;
                                }

                                focaModalService
                                    .alert('Hubo un error al dar de alta esta terminal');
                            });

                    });
            };

            $scope.next = function(key) {

                if(key === 13) $scope.focused ++;
            };

            function terminalLocal() {
                focaConfigurarTerminalService.configTerminal($scope.terminal).then(terminar);
            }

            function terminar() {

                $location.path('/');
            }
        }
    ]);
